#!/usr/bin/env python3
# Para ser usado sin Robot
import socket

HOST    = ''
PORT    = 2334
SIZE    = 32

v = lambda x:f"{x} velocidad"

class Robot:

    def __init__(self):
        pass

    def avanzar(self, velocidad=10):
        print(f"Avanzando a {v(velocidad)}")

    def retroceder(self, velocidad=10):
        print(f"Retrocediendo a {v(velocidad)}")
    
    def izquierda(self, velocidad=10):
        print(f"Virando a la izquierda a {v(velocidad)}")

    def derecha(self, velocidad=10):
        print(f"Virando a la derecha a {v(velocidad)}")

    def atacar(self, velocidad=10, rotation=True):
        if rotation:
            print(f"Rotando Brazo a {v(velocidad)}\n1 rotación")
        else:
            print(f"Rotando Brazo a {v(velocidad)}")

    def perdonar(self):
        print("Deteniendo Brazo")

    def apagar(self):
        print("Apagando Robot")

    def detener(self):
        print("Deteniendo Ruedas")

if __name__ == "__main__":
    print("Inicializando servidor...")
    robot = Robot()
    exit  = False
    while True:
        with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as s:
            s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
            s.bind((HOST, PORT))
            s.listen(5)
            while True:
                try:
                    print("Esperando Cliente...")
                    clientsocket, address = s.accept()
                    with clientsocket:
                        print("Conectado a {}".format(address))
                        data = None
                        key  = None
                        while True:
                            data     = clientsocket.recv(SIZE).decode("utf-8").split(" ")
                            key      = data[0]
                            if data[1] != "":
                                speed = float(data[1])
                                if data[2] != "":
                                    rotation = int(data[2])
                                
                            if key == "apagar":
                                robot.apagar()
                            elif key == "atacar":
                                robot.atacar(speed, rotation)
                            elif key == "avanzar":
                                robot.avanzar(speed)
                            elif key == "derecha":
                                robot.derecha(speed)
                            elif key == "detener":
                                robot.detener()
                            elif key == "izquierda":
                                robot.izquierda(speed)
                            elif key == "perdonar":
                                robot.perdonar()
                            elif key == "retroceder":
                                robot.retroceder(speed)
                            elif key == "pass": # Para comprobar si el la conección murió
                                pass
                            else:
                                print("Clave desconocida: {}".format(data[0]))
                                print("Desconectando...")
                                break; #Aceptar Nuevo Cliente
                except socket.error as e:
                    print(str(e))
                    print("Cliente desconectado")
                except KeyboardInterrupt:
                    exit = True
                    break;
                except Exception as e:
                    print("Error")
                    print(str(e))
                    exit = False
                    break; #Reiniciar
                robot.apagar()
        robot.apagar()
        if exit:
            print("\nSaliendo...")
            break; #Salir
        else:
            print("Reiniciando...")